#include "YF017.h"
#include "pcf8563.h"
#include "delay.h"

static u8 yf017_process_cnt = 0;//ʱʱ
static u8 yf017_process_state = 0;//״̬
static u8 yf017_voice_cnt = 0;//

u8 yf017_start_flag = 0;//ʱ־
u8 Start_Falg = 0;
u8 Voice_Value = 0;//ַ

/*******************************************************************************
 * : void YF017_Init(void)
 * : ʱICʼ
 * β: 
 * : 
 * ˵:  
 ******************************************************************************/
void YF017_Init(void)
{
	GPIO_InitTypeDef  GPIO_InitStructure;

	RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOA,ENABLE);	 //ʹPA˿ʱ

    GPIO_ResetBits(GPIOA,GPIO_Pin_12|GPIO_Pin_15);	
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_12|GPIO_Pin_15;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP; 		 //
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;		 //IOٶΪ50MHz
	GPIO_Init(GPIOA, &GPIO_InitStructure);					 

	GPIO_InitStructure.GPIO_Pin  = GPIO_Pin_11;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IPU;
 	GPIO_Init(GPIOA, &GPIO_InitStructure);   

    YF017_RST = 1;
    delay_ms(2);
    YF017_RST = 0;    
    
    yf017_start_flag = 0;
}

/*******************************************************************************
 * : void YF017_Start(void)
 * : ʱ
 * β: voice_dat:Ƕεַ
 * : 
 * ˵:  
 ******************************************************************************/
void YF017_Start(u8 voice_dat)
{
    yf017_process_state = 0;
    yf017_start_flag = 1;
    Voice_Value = voice_dat;
}

/*******************************************************************************
 * : void YF017_Process_Function(void)
 * : 
 * β: 
 * : 
 * ˵:  
 ******************************************************************************/
void YF017_Process_Function(void)
{
    if(yf017_start_flag)
    {
        switch(yf017_process_state)
        {
            case 0:
            {
                yf017_voice_cnt = 0;
                yf017_process_cnt = 0;
                
                yf017_process_state = 1;
            }
            break;
            
            case 1:
            {
                YF017_RST = 1;
                if(++yf017_process_cnt > 9)
                {
                    yf017_process_cnt = 0;
                    YF017_RST = 0;
                    yf017_process_state = 2;
                }
            }
            break;
            
            case 2:
            {
                if(++yf017_process_cnt > 9)
                {
                    yf017_process_cnt = 0;
                    yf017_process_state = 3;
                }
            }
            break;
            
            case 3:
            {
                YF017_DAT = 1;
                if(++yf017_process_cnt > 1)
                {
                    yf017_process_cnt = 0;
                    yf017_process_state = 4;
                }
            }
            break;
            
            case 4:  
            {
                YF017_DAT = 0;
                if(++yf017_process_cnt > 1)
                {
                    yf017_process_cnt = 0;
                    
                    yf017_voice_cnt++;
                    if(yf017_voice_cnt >= (Voice_Value))
                    {
                        yf017_voice_cnt = 0;
                        yf017_process_state = 5;
                    }
                    else
                    {
                        yf017_process_state = 3;
                    }
                }
            }
            break;
            
            case 5:
            {
                if(YF017_BUSY)
                {
                    yf017_process_state = 0;
                    yf017_start_flag = 0;
                }
            }
            break;
            
            default :
                break;
        }
    }
    else
    {
        YF017_RST = 0;    
    }
}


void Play_Time(void)
{
    static u8 play_time_process_state = 0;
    
    switch(play_time_process_state)
    {
        case 0:
        {
            if((calendar.hour > 8) && (calendar.hour < 21))
            {
                if((calendar.hour != 12) && (calendar.hour != 13))
                {
                    if(((calendar.min == 0) || (calendar.min == 30)) && (calendar.sec == 0))
                    {
                        YF017_Start(22);
                        play_time_process_state = 1;
                    }
                }
            }
            
//            if((calendar.hour > 8) && (calendar.hour < 21))
//            {
//                if(((calendar.min%5 == 0)) && (calendar.sec == 0))
//                {
//                    YF017_Start(22);
//                    play_time_process_state = 1;
//                }
//            }
            
//            if((calendar.hour > 8) && (calendar.hour < 21))
//            {
//                if(calendar.sec == 0)
//                {
//                    YF017_Start(22);
//                    play_time_process_state = 1;
//                }
//            }
        }
        break;
        
        case 1:
        {
            if(yf017_start_flag == 0)
            {
                if((calendar.hour/10) == 2)
                {
//                    if(calendar.hour%10)
//                    {
//                        YF017_Start(calendar.hour/10 + 1);
//                    } 
                    
                    YF017_Start(calendar.hour/10 + 1);
                    
                    play_time_process_state = 2;
                }
                else if((calendar.hour/10) == 1)
                {
                    play_time_process_state = 2;
                }
                else
                {
                     play_time_process_state = 3;                   
                }
            }
        }
        break;
        
        case 2:
        {
            if(yf017_start_flag == 0)
            {
                YF017_Start(11);
                play_time_process_state = 3;                
            }                
        }
        break;
        
        case 3:
        {
            if(yf017_start_flag == 0)
            {
                if((calendar.hour/10) == 0)
                {
                    YF017_Start(calendar.hour%10 + 1);
                }
                else
                {
                    if((calendar.hour%10) != 0)
                    {
                        YF017_Start(calendar.hour%10 + 1);
                    }
                }
                play_time_process_state = 4;                
            }                
        }
        break;
        
        case 4:
        {
            if(yf017_start_flag == 0)
            {
                YF017_Start(13);
                play_time_process_state = 5;                
            }             
        }
        break;
        
        case 5:
        {
            if(yf017_start_flag == 0)
            {
                if(calendar.min/10)
                {
                    YF017_Start(calendar.min/10 + 1);
                    play_time_process_state = 6;
                }
                else
                {
                    YF017_Start(26);
                    play_time_process_state = 8;                   
                }
            }          
        }
        break;
        
        case 6:
        {
            if(yf017_start_flag == 0)
            {
                YF017_Start(11);
                play_time_process_state = 7;                
            }               
        }
        break;
        
        case 7:
        {
            if(yf017_start_flag == 0)
            {
                if(calendar.min%10)
                {
                    YF017_Start(calendar.min%10 + 1);
                }

                play_time_process_state = 9;                
            }                
        }
        break;
        
        case 8:
        {
            if(yf017_start_flag == 0)
            {
                play_time_process_state = 10;
            }                
        }
        break;
        
        case 9:
        {
            if(yf017_start_flag == 0)
            {
                YF017_Start(14);
                play_time_process_state = 10;                
            }              
        }
        break;
        
        case 10:
        {
            if(yf017_start_flag == 0)
            {
                play_time_process_state = 0;                
            }             
        }
        break;
        
        default :
            break;
    }
}






