
#include "led_16x32.h"
#include "delay.h"

void LED_16x32_Init(void)
{
	GPIO_InitTypeDef  GPIO_InitStructure;

	RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOB,ENABLE);	 //ʹPB˿ʱ
    RCC_APB2PeriphClockCmd(RCC_APB2Periph_AFIO,ENABLE); 
    GPIO_PinRemapConfig(GPIO_Remap_SWJ_JTAGDisable, ENABLE);     /*ʹSWD JTAG*/

	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_4|GPIO_Pin_5|GPIO_Pin_6|GPIO_Pin_7|GPIO_Pin_8|GPIO_Pin_9;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP; 		 
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_10MHz;		
	GPIO_Init(GPIOB, &GPIO_InitStructure);					 
	GPIO_SetBits(GPIOB,GPIO_Pin_4|GPIO_Pin_5|GPIO_Pin_6|GPIO_Pin_7|GPIO_Pin_8|GPIO_Pin_9);
    //GPIO_ResetBits(GPIOB,GPIO_Pin_4|GPIO_Pin_5|GPIO_Pin_6|GPIO_Pin_7|GPIO_Pin_8|GPIO_Pin_9);    
}

//-------------------------------------------------------------
//  ƣOut_Abyte_595 
//  DATA_IN
//  
//  ˵74HC595 8λ 
//-------------------------------------------------------------
void Out_Abyte_595(u8 Byte_IN1,u8 Byte_IN2) 
{  
    u8 i;
    
	i=8;	
	do
	{ 
		if((Byte_IN2&0x01)==0x01)  /*λΪ1SDATA_5951*/
		    DAT_595 = 0;           /*ݵλ*/
		else  
		    DAT_595 = 1;
		CLK_595 = 0;
		//delay_us(2);
	    CLK_595 = 1;
		Byte_IN2>>=1;
	}while(--i!=0);
    
	i=8;	
	do
	{ 
		if((Byte_IN1&0x01)==0x01)  /*λΪ1SDATA_5951*/
		    DAT_595 = 0;           /*ݵλ*/
		else  
		    DAT_595 = 1;
		CLK_595 = 0;
		//delay_us(2);
	    CLK_595 = 1;
		Byte_IN1>>=1;
	}while(--i!=0);
    
	LATCH_595 = 0;
    //delay_us(2);
	LATCH_595 = 1;	
}

void Send_Data_164(u32 send_dat)
{
    u8 i = 0;
    
    for(i = 0;i < 32;i++)
    {
        if((send_dat & 0x0001) == 0x0001)
        {
            DAT_164 = 0;
        }
        else
        {
            DAT_164 = 1;
        }
        
        send_dat >>= 1;
        
        CLK_164 = 0;
        delay_us(1);
        CLK_164 = 1;
    }
}
 
//-------------------------------------------------------------
//  ƣDispaly_Achar 
//  
//  
//  ˵74HC164 8λ 
//-------------------------------------------------------------
void Dispaly_Achar(u8 N,u8 *Buf) 
 {  
 	u16 i;
	u16 j;
	u16 k;
	u8 m;
	for(k=0;k<224;k++)//14
	{
		for(m=0;m<N;m++)
		{
			for(i=0;i<Lin/4;i++)
			{
			    for(j=0;j<32;j++)
				{ 	
					if((2*(j+k)+1) < 448)
					{
						Out_Abyte_595(Buf[2*(j+k)],Buf[2*(j+k)+1]);
                        Out_Abyte_595(0x00,0x00);
					}
					else
					{
                        Out_Abyte_595(0x00,0x00);
					}
                    
                    if(j == 0)  /*λΪ1SDATA_5951*/
                    {
                        DAT_164 = 0;       /*ݵλ*/
                    }
                    else  
                    {
                        DAT_164 = 1;
                    }
					
//                    if(k < 192)
//                    {
//                        if(j == 0)  /*λΪ1SDATA_5951*/
//                        {
//                            DAT_164 = 0;       /*ݵλ*/
//                        }
//                        else  
//                        {
//                            DAT_164 = 1;
//                        }
//                    }
//                    else
//                    {
//                        DAT_164 = 1;
//                    }
					
					CLK_164 = 0;
                    delay_us(2);
				    CLK_164 = 1;
				}
			}
		}
	}
}
 
