/*******************************************************************************
 * ļ  pcf8563.c
 *     RTCʵʱʱӳ
 * ʵƽ̨
 * 汾  V1.5.1
 *     liuyong
 *޸ʱ 2014-05-07
*******************************************************************************/

#include "myiic.h"
#include "pcf8563.h"

_calendar_obj calendar;	//ṹ
_chinacalendar_obj chinacalendar;

_calendar_obj INIT_TIME = {2017,2,5,18,29,50,0};

void PCF8563_TimeInit(void)
{
    PCF8563_SetTime(&INIT_TIME);
}

/*******************************************************************************
 * : void PCF8563_Init(void)
 * : pcf8563ʼ
 * β: 
 * : 
 * ˵:  
 ******************************************************************************/
u8 PCF8563_Init(void)
{
    u8 buf[2];
    
    PCF8563_ReadOneByteStr(2,buf,1);
    
    if((buf[0] & 0x80) != 0)        // ȽVL־, ûоʼʼʱ
    {
        //PCF8563_SetTime(&INIT_TIME);
        return 0;
    }
    
    buf[0] = 0;                 // /״̬Ĵ 00H
    buf[1] = 0;                 // /״̬Ĵ 01H     
    PCF8563_WriteOneByteStr(0,buf,2);  
    
    return 1;
}

/*******************************************************************************
 * : u8 PCF8563_GetTime(_calendar_obj *datetime)
 * : Pcf8563ȡʱ亯
 * β: 
 * : 
 * ˵:  
 ******************************************************************************/
u8 PCF8563_GetTime(_calendar_obj *datetime)
{
    u8 buf[7];
    u8 read_ste;
    
    read_ste = PCF8563_ReadOneByteStr(2,buf,7);
    if(read_ste == 0) return 0;
    
    if((buf[5] & 0x80) == 0)
    {
        datetime->w_year = 2000;    
    }else{
        datetime->w_year = 1900; 
        buf[5] &= 0x7f;   
    }
    
    datetime->sec = changeHexToDec(buf[0]);	
    datetime->min = changeHexToDec(buf[1]);	
    datetime->hour = changeHexToDec(buf[2]);	
    datetime->w_day = changeHexToDec(buf[3]);	
    //datetime->week = changeHexToDec(buf[4]);	
    datetime->w_month = changeHexToDec(buf[5]);	
    datetime->w_year += changeHexToDec(buf[6]);	
    
    return 1;
}
/*******************************************************************************
 * : u8 PCF8563_SetTime(_calendar_obj *datetime)
 * : Pcf8563дʱ亯
 * : *datetime:дʱ
 * ˵:  
 ******************************************************************************/
u8 PCF8563_SetTime(_calendar_obj *datetime)
{
    u8 buf[7];
    
    buf[0] = changeDecToHex(datetime->sec);	 //ݵDexʽתΪHexʽ
    buf[1] = changeDecToHex(datetime->min);
    buf[2] = changeDecToHex(datetime->hour);
    buf[3] = changeDecToHex(datetime->w_day);
    buf[4] = changeDecToHex(datetime->week);
    buf[5] = changeDecToHex(datetime->w_month);
    
    buf[6] = (((datetime->w_year/10)%10)<<4) | (datetime->w_year%10);
    if(datetime->w_year < 2000)
    {
        buf[5] |= 0x80;//ָΪ19XX
    }
    
    return PCF8563_WriteOneByteStr(0x02,buf,7);
}

/*******************************************************************************
 * : void PCF8563_WriteOneByte(INT8U addr,INT8U dat)
 * : Pcf8563дֽں
 * β: addrдĵַ
         datд
 * : 0дʧܣ
         1дɹ
 * ˵:  
 ******************************************************************************/
u8 PCF8563_WriteOneByte(u8 addr,u8 dat)
{
    u8 ack_state = 0;
    
    I2C_Start();
    
    I2C_WriteByte(WD_DADR);
    ack_state = I2C_Wait_Ack();
    if(ack_state) return 0;//Ӧ𣬷
    
    I2C_WriteByte(addr);
    ack_state = I2C_Wait_Ack();//Ӧ𣬷
    if(ack_state) return 0;
    
    I2C_WriteByte(dat);
    ack_state = I2C_Wait_Ack();//Ӧ𣬷
    if(ack_state) return 0;
    
    I2C_Stop();
    
    return 1;
}

/*******************************************************************************
 * : u8 PCF8563_WriteOneByteStr(u8 addr,u8 *s,u8 num)
 * : Pcf8563дֽں
 * β: addrдĵַ
         *sд
         numдֽ
 * : 0дʧܣ
         1дɹ
 * ˵:  
 ******************************************************************************/
u8 PCF8563_WriteOneByteStr(u8 addr,u8 *s,u8 num)
{
    u8 ack_state = 0;
    u8 i = 0;
    
    I2C_Start();
    
    I2C_WriteByte(WD_DADR);
    ack_state = I2C_Wait_Ack();
    if(ack_state) return 0;//Ӧ𣬷
    
    I2C_WriteByte(addr);
    ack_state = I2C_Wait_Ack();//Ӧ𣬷
    if(ack_state) return 0;
    
    for(i = 0;i < num;i++)
    {
        I2C_WriteByte(*s);
        ack_state = I2C_Wait_Ack();//Ӧ𣬷
        if(ack_state) return 0;
        s++;
    }
    
    I2C_Stop();
    
    return 1;
}


/*******************************************************************************
 * : u8 PCF8563_ReadOneByte(u8 ReadAddr,u8 *dat)
 * : Pcf8563ֽں
 * β: ReadAddrҪֽڵĵַ
         *Dat:ȡ
 * : 0ʧ
         1ɹ
 * ˵:  
 ******************************************************************************/
u8 PCF8563_ReadOneByte(u8 ReadAddr,u8 *dat)
{
    u8 ack_state = 0;

    I2C_Start();
    
    I2C_WriteByte(WD_DADR);
    ack_state = I2C_Wait_Ack();//Ӧ𣬷
    if(ack_state) return 0;
    
    I2C_WriteByte(ReadAddr);
    ack_state = I2C_Wait_Ack();//Ӧ𣬷
    if(ack_state) return 0;
    
    I2C_Start();
    
    I2C_WriteByte(RD_DADR);
    ack_state = I2C_Wait_Ack();//Ӧ𣬷
    if(ack_state) return 0;
    
    *dat = I2C_ReadByte(0);
    I2C_Stop();//һֹͣ
    return 1;
}

/*******************************************************************************
 * : u8 PCF8563_ReadOneByteStr(u8 ReadAddr,u8 *s,u8 num)
 * : Pcf8563ֽں
 * β: ReadAddrҪֽڵĵַ
         *s:ȡ
         numҪȡֽ
 * : 0ʧ
         1ɹ
 * ˵:  
 ******************************************************************************/
u8 PCF8563_ReadOneByteStr(u8 ReadAddr,u8 *s,u8 num)
{
    u8 i = 0;
    u8 ack_state = 0;

    I2C_Start();
    
    I2C_WriteByte(WD_DADR);
    ack_state = I2C_Wait_Ack();//Ӧ𣬷
    if(ack_state) return 0;
    
    I2C_WriteByte(ReadAddr);
    ack_state = I2C_Wait_Ack();//Ӧ𣬷
    if(ack_state) return 0;
    
    I2C_Start();
    
    I2C_WriteByte(RD_DADR);
    ack_state = I2C_Wait_Ack();//Ӧ𣬷
    if(ack_state) return 0;
    
    for(i = 0;i < (num - 1);i++)
    {
        *s = I2C_ReadByte(1);
        s++;
    }
    
    *s = I2C_ReadByte(0);
    
    I2C_Stop();//һֹͣ
    return 1;
}

//void main(void)
//{
//    U16 i;              // ѭñ
//    U16 ret;
//    U8  chr;
//    U32 cnt = 0;

//    P4SW = 0X70;        // P4˿ΪIO
//     
//    NO_CALL();

//    UartInit();         // ʼж Զ
//    UART_SendString("ڳʼ!\r\n");      // 򴮿ڷַ
//    ret = PCF8563_Init();        // ʼʱģ
//    if(ret == FALSE)
//    {
//        UART_SendString("ʱδ,ʱ!\r\n");      // 򴮿ڷַ
//        // մڻ
//        while(UART_RecvChar_N(&chr) == TRUE);
//        ReSetTime();
//    }else{
//        UART_SendString("ʱģģʼɹ!\r\n");      // 򴮿ڷַ
//    }

//    for(i = 0;i<3;i++)
//    {
//        P0 = 0;         // ˸ȫ
//        delay(20000);   // ʱһʱ
//        P0 = 0xff;      // ˸ȫ
//        delay(10000);   // ʱһʱ
//    }
//    // մڻ
//    while(UART_RecvChar_N(&chr) == TRUE);

//    UART_SendString("\r\n");
//    UART_SendString("\r\n");
//    UART_SendString("***************************************\r\n"); 
//    UART_SendString("*   SQUIRREL_STC12C5A60S2   *\r\n");
//    UART_SendString("*                                     *\r\n");
//    UART_SendString("*      ʵʱʱʾ-ڲ˵      *\r\n");
//    UART_SendString("*                                     *\r\n");
//    UART_SendString("*         R207SC@SQUIRREL_51          *\r\n");
//    UART_SendString("***************************************\r\n");
//    UART_SendString("\r\n");

//    PutNowTime();
//    ShowMenu();
//    cnt = 0;
//    while(1)
//    {
//        chr = UART_RecvChar();      // ģʽӴڶȡһַ
//        UART_SendChar(chr);         // Ըַ

//        switch(chr)                 // ݶַ ִӦĹ
//        {
//        case '1':   // ϵͳʱ
//            ReSetTime();
//            ShowMenu();  
//            break;
//        case '2':   // ʾϵͳʱ
//            PutNowTime();
//            break;
//        case '?':   // ʾ˵
//            ShowMenu();  
//            break;
//        }
//    }
//}


