#include "remote.h"
#include "delay.h"

static u32 R_Buf = 0;                               
static u32 RecvData = 0;                          

static u8 TimeServerOld = 0;  
static u8 RecvCnt = 0; 
static u32 TimeServerCnt = 0;   

/***************************************
0         1         2         3
ID    ID뷴        뷴
***************************************/
u8 IrCode[4] = {0,0,0,0};
 	  		  

//ʼŵ
void Remote_Init(void)
{							 
	GPIO_InitTypeDef GPIO_InitStructure;	//GPIO
 		 
	RCC_APB2PeriphClockCmd(	RCC_APB2Periph_GPIOC, ENABLE );	  
 
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_5;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IPU ;  //
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
	GPIO_Init(GPIOC, &GPIO_InitStructure);  
    
    R_Buf = 0;
    RecvCnt  = 0;
    RecvData = 0;
}   

//U16 R_Buf = 0x5555;
// 
static void DeCode(u32 Cnt)
{
    if((Cnt > IR_START) && (Cnt < (IR_START + DataTolerance_IR))){        // 
        RecvCnt  = 0;
        RecvData = 0;
    }else if((Cnt > IR_BIT1) && (Cnt < (IR_BIT1 + DataTolerance_IR))){   // BIT1
        RecvData <<= 1;
        RecvData  |= 1;
        RecvCnt++;
    }else if((Cnt > IR_BIT0) && (Cnt < (IR_BIT0 + DataTolerance_IR))){   // BIT0
        RecvData <<= 1;
        RecvCnt++;
    }else if((Cnt > IR_PRESS) && (Cnt < (IR_PRESS + DataTolerance_IR))){ // ظ
        R_Buf      = RecvData;
        //HS0038B_PutData(OldData);   
    }else{
        RecvCnt  = 0;
        RecvData = 0;
    }
    if(RecvCnt >= 32)
    {
        R_Buf      = RecvData;
        RecvCnt = 0;
        RecvData = 0;
    }
} 

// ÿ100000ε
void HS0038B_TimeServer(void)
{
    TimeServerCnt++;
    if(RDATA == 0)
    {
        if(TimeServerOld == 1)
        {
            DeCode(TimeServerCnt);
            TimeServerCnt = 0;
        }
        TimeServerOld = 0;
    }else{
        TimeServerOld = 1;
    }     
}

// ӻ
u8 HS0038B_GetData(u8 *Data)
{
    u32 tmp;
    
    tmp   = R_Buf;
    R_Buf = 0;
    if(tmp != 0)
    {
        Data[0] = tmp >> 24;
        Data[1] = tmp >> 16;
        Data[2] = tmp >> 8;
        Data[3] = tmp;
        
        return 1;
    }else{
        return 0;
    }
}






















