#include "sys.h"
#include "delay.h"
#include "usart.h"
#include "led.h"
#include "GT30L24A3W.h"
#include "spi.h"
#include "dht11.h"
#include "timer.h"
#include "pcf8563.h"
#include "remote.h"
#include "YF017.h"
#include "key.h"
#include "disp_menu.h"
#include "beep.h"

extern void Disp_Process(void);

u32 time_500ms = 0;

u8 time_250us_flag = 0;

static u8 time_2ms_cnt = 0;
u8 time_2ms_flag = 0;

static u8 time_10ms_cnt = 0;
u8 time_10ms_flag = 0;

static u8 time_100ms_cnt = 0;
u8 time_100ms_flag = 0;

//////////////////////////////////////////////////////////////////////////////////	 
//ֻѧϰʹãδɣκ;
//ALIENTEKսSTM32
//ʱ 	   
//ԭ@ALIENTEK
//̳:www.openedv.com
//޸:2012/9/3
//汾V1.0
//ȨУؾ
//Copyright(C) ӿƼ޹˾ 2009-2019
//All rights reserved									  
//////////////////////////////////////////////////////////////////////////////////   	 

//TIM3 PWMֳʼ 
//PWMʼ
//arrԶװֵ
//pscʱԤƵ
void TIM1_PWM_Init(u16 arr,u16 psc)
{  
	TIM_TimeBaseInitTypeDef  TIM_TimeBaseStructure;
	TIM_OCInitTypeDef  TIM_OCInitStructure;
	
 	RCC_APB2PeriphClockCmd(RCC_APB2Periph_TIM1,ENABLE);  //ʹGPIOAFIOùģʱ
	 
   //ʼTIM1
	TIM_TimeBaseStructure.TIM_Period = arr; //һ¼װԶװؼĴڵֵ
	TIM_TimeBaseStructure.TIM_Prescaler =psc; //ΪTIMxʱƵʳԤƵֵ 
	TIM_TimeBaseStructure.TIM_ClockDivision = 0; //ʱӷָ:TDTS = Tck_tim
	TIM_TimeBaseStructure.TIM_CounterMode = TIM_CounterMode_Up;  //TIMϼģʽ
    TIM_TimeBaseStructure.TIM_RepetitionCounter = 0;
	TIM_TimeBaseInit(TIM1, &TIM_TimeBaseStructure); //TIM_TimeBaseInitStructָĲʼTIMxʱλ
    TIM_ARRPreloadConfig(TIM1, ENABLE);
	
	//ʼTIM1 Channel1 PWMģʽ	 
	TIM_OCInitStructure.TIM_OCMode = TIM_OCMode_PWM2; //ѡʱģʽ:TIMȵģʽ2
 	TIM_OCInitStructure.TIM_OutputState = TIM_OutputState_Enable; //Ƚʹ
	TIM_OCInitStructure.TIM_OCPolarity = TIM_OCPolarity_High; //:TIMȽϼԸ
    TIM_OCInitStructure.TIM_OCIdleState  = TIM_OCIdleState_Reset;
    TIM_OCInitStructure.TIM_Pulse = 0;
	TIM_OC1Init(TIM1, &TIM_OCInitStructure);  //TָĲʼTIM1 OC1

	TIM_OC1PreloadConfig(TIM1, TIM_OCPreload_Enable);  //ʹTIM1CCR1ϵԤװؼĴ
 
	TIM_Cmd(TIM1, ENABLE);  //ʹTIM1
    TIM_CtrlPWMOutputs(TIM1, ENABLE);
}

static void Led_Breathe_Process(void)
{
    static u16 led0pwmval=0;
    static u8 dir=1;
    
    if((calendar.hour > 5) && (calendar.hour < 21))//㵽21ſ
    {    
        TIM_CtrlPWMOutputs(TIM1, ENABLE);
        if(dir)
        {
            led0pwmval++;
        }
        else 
        {
            led0pwmval--;
        }

        if(led0pwmval > 500)
        {
            dir = 0;
        }
        if(led0pwmval == 0)
        {
            dir = 1;		
        } 

        TIM_SetCompare1(TIM1,led0pwmval);	
    }
    else
    {
        GPIO_ResetBits(GPIOA,GPIO_Pin_8);
        led0pwmval = 0;
        dir = 1;
        TIM_CtrlPWMOutputs(TIM1, DISABLE);
        TIM_SetCompare1(TIM1,0);	
    }
}

//ͨöʱ3жϳʼ
//ʱѡΪAPB12APB1Ϊ36M
//arrԶװֵ
//pscʱԤƵ
//ʹõǶʱ3!
void TIM3_Int_Init(u16 arr,u16 psc)
{
    TIM_TimeBaseInitTypeDef  TIM_TimeBaseStructure;
	NVIC_InitTypeDef NVIC_InitStructure;

	RCC_APB1PeriphClockCmd(RCC_APB1Periph_TIM3, ENABLE); //ʱʹ
	
	//ʱTIM3ʼ
	TIM_TimeBaseStructure.TIM_Period = arr; //һ¼װԶװؼĴڵֵ	
	TIM_TimeBaseStructure.TIM_Prescaler =psc; //ΪTIMxʱƵʳԤƵֵ
	TIM_TimeBaseStructure.TIM_ClockDivision = TIM_CKD_DIV1; //ʱӷָ:TDTS = Tck_tim
	TIM_TimeBaseStructure.TIM_CounterMode = TIM_CounterMode_Up;  //TIMϼģʽ
	TIM_TimeBaseInit(TIM3, &TIM_TimeBaseStructure); //ָĲʼTIMxʱλ
 
	TIM_ITConfig(TIM3,TIM_IT_Update,ENABLE ); //ʹָTIM3ж,ж

	//жȼNVIC
	NVIC_InitStructure.NVIC_IRQChannel = TIM3_IRQn;  //TIM3ж
	NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 0;  //ռȼ0
	NVIC_InitStructure.NVIC_IRQChannelSubPriority = 3;  //ȼ3
	NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE; //IRQͨʹ
	NVIC_Init(&NVIC_InitStructure);  //ʼNVICĴ


	TIM_Cmd(TIM3, ENABLE);  //ʹTIMx					 
}

void TIM2_Int_Init(u16 arr,u16 psc)
{
    TIM_TimeBaseInitTypeDef  TIM_TimeBaseStructure;
	NVIC_InitTypeDef NVIC_InitStructure;

	RCC_APB1PeriphClockCmd(RCC_APB1Periph_TIM2, ENABLE); //ʱʹ
	
	//ʱTIM3ʼ
	TIM_TimeBaseStructure.TIM_Period = arr; //һ¼װԶװؼĴڵֵ	
	TIM_TimeBaseStructure.TIM_Prescaler =psc; //ΪTIMxʱƵʳԤƵֵ
	TIM_TimeBaseStructure.TIM_ClockDivision = TIM_CKD_DIV1; //ʱӷָ:TDTS = Tck_tim
	TIM_TimeBaseStructure.TIM_CounterMode = TIM_CounterMode_Up;  //TIMϼģʽ
	TIM_TimeBaseInit(TIM2, &TIM_TimeBaseStructure); //ָĲʼTIMxʱλ
 
	TIM_ITConfig(TIM2,TIM_IT_Update,ENABLE ); //ʹָTIM2ж,ж

	//жȼNVIC
	NVIC_InitStructure.NVIC_IRQChannel = TIM2_IRQn;  //TIM2ж
	NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 0;  //ռȼ0
	NVIC_InitStructure.NVIC_IRQChannelSubPriority = 3;  //ȼ3
	NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE; //IRQͨʹ
	NVIC_Init(&NVIC_InitStructure);  //ʼNVICĴ


	TIM_Cmd(TIM2, ENABLE);  //ʹTIMx					 
}

//ʱ3жϷ
void TIM3_IRQHandler(void)   //TIM3ж
{
    if(TIM_GetITStatus(TIM3, TIM_IT_Update) != RESET)  //TIM3жϷ
    {
        Disp_Process();
        
        TIM_ClearITPendingBit(TIM3, TIM_IT_Update  );  //TIMxжϱ־ 
    }
}

void TIM2_IRQHandler(void)   //TIM2ж
{
    if(TIM_GetITStatus(TIM2, TIM_IT_Update) != RESET)  //TIM3жϷ
    {
        Beep_Speaker();
        EncodeKey_Check();
        
        time_250us_flag = 1;
        YF017_Process_Function();
        time_2ms_cnt++;
        if(time_2ms_cnt > 7)
        {
            time_2ms_cnt = 0;
            time_2ms_flag = 1;
            process_key();
            time_10ms_cnt++;
            if(time_10ms_cnt > 4)
            {
                time_10ms_cnt = 0;
                time_10ms_flag = 1;
                
                Led_Breathe_Process();
                Beep_Control1();
                EncodeKey_Process();
                Flicker_Process();
                time_100ms_cnt++;
                if(time_100ms_cnt > 9)
                {
                    time_100ms_cnt = 0;
                    time_100ms_flag = 1;
                }
            }
        }
        
        HS0038B_TimeServer();
        
        TIM_ClearITPendingBit(TIM2, TIM_IT_Update  );  //TIMxжϱ־ 
    }
}












