#include "sys.h"
#include "delay.h"
#include "usart.h"
#include "led.h"
#include "GT30L24A3W.h"
#include "spi.h"
#include "timer.h"
#include "pcf8563.h"
#include "remote.h"
#include "led_16x32.h"
#include "key.h"
#include "myiic.h"
#include "stmflash.h"
#include "YF017.h"
#include "disp_menu.h"
#include "calendar.h"
#include "beep.h"
#include "string.h"
#include "adc.h"

u8 dht11_check_flag = 0;//ʪȴǷڼ־
u8 week_buf;

int main(void)
{		
    u16 first_poweron_falg = 0;
    u16 hour_dat = 0;
    u8 hour_dat1 = 0;
    u8 min_dat = 0;
    u8 time_sec_pro = 0;
    
	delay_init();	    	 //ʱʼ	  
	NVIC_Configuration(); 	 //NVICжϷ2:2λռȼ2λӦȼ
	uart_init(115200);	 //ڳʼΪ115200
    
    delay_ms(50);
    
    PCF8563_Init();
    
    STMFLASH_Read(FLASH_SAVE_ADDR,&first_poweron_falg,1);
    
    if(first_poweron_falg != 0x5C5B)
    {
		first_poweron_falg = 0x5C5B;
		STMFLASH_Write(FLASH_SAVE_ADDR,&first_poweron_falg,1);
        
        PCF8563_TimeInit();
    }
    else
    {
        PCF8563_GetTime(&calendar);
    }
    
	LED_Init();
	Gt30l_Font_Init();
    TIM3_Int_Init(199,71);//1MHzƵʣ200Ϊ200us200usжһ
    TIM2_Int_Init(249,71);//1MHzƵʣ250Ϊ250us250usжһ
    I2C_Init();
    Key_Init();
    Beep_Init();
    Adc_Init();
    
    TIM1_PWM_Init(899,0); //ƵPWMƵ=72000000/900=80Khz
     
	LED_16x32_Init();
     
    CLR_164 = 0;
    delay_us(10);
    CLR_164 = 1;
	 
    Function_Value = 0;
    
    YF017_Init();
        
	while(1)
	{
        if(time_250us_flag)
        {
            time_250us_flag = 0;
        }
        
        if(time_2ms_flag)
        {
            time_2ms_flag = 0;
        }
        
        if(time_10ms_flag)
        {
            time_10ms_flag = 0;
            
            Play_Time();
        }
        
        if(time_100ms_flag)
        {
            time_100ms_flag = 0;
            
            if((Function_Value < 4) || (Function_Value > 10))//ڼ䲻ȡ
            {
                PCF8563_GetTime(&calendar);
                
                STMFLASH_Read(FLASH_SAVE_HOUR,&hour_dat,1);
                hour_dat1 = hour_dat >> 8;
                min_dat = hour_dat;
                
                if((calendar.hour == hour_dat1) && (calendar.min == (min_dat - 1)))
                {
                    if(time_sec_pro == 0)//һ12롣
                    {
                        calendar.sec +=  48;
                        calendar.min--;
                        
                        PCF8563_SetTime(&calendar);  
                        time_sec_pro = 1;
                    }
                }
                else
                {
                    if((calendar.hour == hour_dat1) && (calendar.min == (min_dat + 1)))
                    {
                        time_sec_pro = 0;
                    }
                }
                
                if(day_buf != calendar.w_day)
                {
                    Clear_DatBuf(LunarCalendar_Num);
                    Clear_DatBuf(SolarCalendar_Num);
                    Lunar_Festival_Flag = 0;
                    Solar_Festival_Flag = 0;
                    
                    day_buf = calendar.w_day;
                    GetWeek(calendar.w_year,calendar.w_month,calendar.w_day,&week_buf);
                    calendar.week = week_buf;
                    
                    SolarCalendarFestival_Process();
                    GetHzInternalCode_Str(SolarCalendar_Num,SolarCalendar_Str,strlen(SolarCalendar_Str)/2);
                    
                    GetChinaCalendar(calendar.w_year,calendar.w_month,calendar.w_day,&chinacalendar);
                    LunarCalendarFestival_Process();
                    GetHzInternalCode_Str(LunarCalendar_Num,LunarCalendar_Str,strlen(LunarCalendar_Str)/2);
                    
                    GetChinaCalendarStr(calendar.w_year,calendar.w_month,calendar.w_day,CHCalendarStr);
                    GetHzInternalCode_Str(DataBuf,CHCalendarStr,7);
                    GetShengXiaoStr(calendar.w_year,calendar.w_month,calendar.w_day,Zodiac);
                    GetHzInternalCode_Str(Zodiac_Num,Zodiac,1);
                    SolarTerms_Flag = GetJieQiStr(calendar.w_year,calendar.w_month,calendar.w_day,SolarTerms);
                    GetHzInternalCode_Str(SolarTerms_Num,SolarTerms,7);
                }
            }
            
            ADC_GetConversionValue1();
        }
	}
}




 
 

